/**
* @version $Id: common.js 3424 2006-05-10 02:05:13Z Jinx $
* @copyright Copyright (C) 2005 - 2006 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

/**
 * Common javascript funtionality
 *
 * @author		Johan Janssens <johan.janssens@joomla.org>
 * @package		Joomla
 * @since		1.5
 * @version     1.0
 */

/* -------------------------------------------- */
/* -- Browser information --------------------- */
/* -------------------------------------------- */

Browser = new Object();
Browser.agt     = navigator.userAgent.toLowerCase();
Browser.is_ie	= ((Browser.agt.indexOf("msie") != -1) && (Browser.agt.indexOf("opera") == -1));

/* -------------------------------------------- */
/* -- page loader ----------------------------- */
/* -------------------------------------------- */

document.addLoadEvent= function(func) {
  var oldonload = window.onload;
  if (typeof window.onload != 'function') {
    window.onload = func;
  } else {
    window.onload = function() {
      oldonload();
      func();
    }
  }
}

/* gap is in millisecs */
function delay(gap) {
	var then,now; then=new Date().getTime();
	now=then;
	while((now-then)<gap)
	{now=new Date().getTime();}
}

/* -------------------------------------------- */
/* -- functions ------------------------------- */
/* -------------------------------------------- */

/* ---------------------------------------------------------------------------- */
/*  Prototype JavaScript framework
 *  (c) 2005 Sam Stephenson <sam@conio.net>
 *  Prototype is freely distributable under the terms of an MIT-style license.
 *  For details, see the Prototype web site: http://prototype.conio.net/
/* ---------------------------------------------------------------------------- */

//note: modified & stripped down version of prototype, to be used with Joomla! 1.5

var Class = {
	create: function() {
		return function() {
			this.initialize.apply(this, arguments);
		}
	}
}

Object.extend = function(destination, source) {
	for (property in source) destination[property] = source[property];
	return destination;
}

Function.prototype.bind = function(object) {
	var __method = this;
	return function() {
		return __method.apply(object, arguments);
	}
}

Function.prototype.bindAsEventListener = function(object) {
var __method = this;
	return function(event) {
		__method.call(object, event || window.event);
	}
}

function $() {
	if (arguments.length == 1) return get$(arguments[0]);
	var elements = [];
	$c(arguments).each(function(el){
		elements.push(get$(el));
	});
	return elements;

	function get$(el){
		if (typeof el == 'string') el = document.getElementById(el);
		return el;
	}
}

if (!window.Element) var Element = new Object();

Object.extend(Element, {
	remove: function(element) {
		element = $(element);
		element.parentNode.removeChild(element);
	},

	hasClassName: function(element, className) {
		element = $(element);
		if (!element) return;
		var hasClass = false;
		element.className.split(' ').each(function(cn){
			if (cn == className) hasClass = true;
		});
		return hasClass;
	},

	addClassName: function(element, className) {
		element = $(element);
		Element.removeClassName(element, className);
		element.className += ' ' + className;
	},

	removeClassName: function(element, className) {
		element = $(element);
		if (!element) return;
		var newClassName = '';
		element.className.split(' ').each(function(cn, i){
			if (cn != className){
				if (i > 0) newClassName += ' ';
				newClassName += cn;
			}
		});
		element.className = newClassName;
	},

	cleanWhitespace: function(element) {
		element = $(element);
		$c(element.childNodes).each(function(node){
			if (node.nodeType == 3 && !/\S/.test(node.nodeValue)) Element.remove(node);
		});
	},

	find: function(element, what) {
		element = $(element)[what];
		while (element.nodeType != 1) element = element[what];
		return element;
	}
});

var Position = {
	cumulativeOffset: function(element) {
		var valueT = 0, valueL = 0;
		do {
			valueT += element.offsetTop  || 0;
			valueL += element.offsetLeft || 0;
			element = element.offsetParent;
		} while (element);
		return [valueL, valueT];
	}
};

document.getElementsByClassName = function(className) {
	var children = document.getElementsByTagName('*') || document.all;
	var elements = [];
	$c(children).each(function(child){
		if (Element.hasClassName(child, className)) elements.push(child);
	});
	return elements;
}

//useful array functions
Array.prototype.each = function(func){
	for(var i=0;ob=this[i];i++) func(ob, i);
}

function $c(array){
	var nArray = [];
	for (i=0;el=array[i];i++) nArray.push(el);
	return nArray;
}

JSwitcher = function() { this.initialize.apply(this, arguments);}
JSwitcher.prototype = {

	initialize: function(toggler, element)
	{
		var self = this;

		togglers = toggler.getElementsByTagName('A');
		for (i=0; i < togglers.length; i++) {
			togglers[i].onclick = function() {
				self.switchTo(this.getAttribute('id'));
			}
		}

		//hide all
		elements = element.getElementsByTagName('DIV');
		for (i=0; i < elements.length; i++) {
			this.hide(elements[i])
		}
	},

	switchTo: function(id)
	{
		toggler = document.getElementById(id);
		element = document.getElementById('page-'+id);

		if(element)
		{
			//hide old element
			if(this.active) {
				this.hide(this.active);
			}

			//show new element
			this.show(element);

			toggler.className = 'active';
			if (this.test) {
				document.getElementById(this.test).className = '';
			}
			this.active = element;
			this.test = id;
		}
	},

	hide: function(element) {
		this.setVisibility(element, false);
	},

	show: function (element) {
		this.setVisibility(element, true);
	},

	setVisibility: function(element, bShow) {
		element.style.display = bShow ? "block" : "none"
	}
}

document.switcher = null;
document.addLoadEvent(function() {
 	toggler = document.getElementById('submenu')
  	element = document.getElementById('tab-document')
  	if(element) {
  		document.switcher = new JSwitcher(toggler, element)
  	 	document.switcher.switchTo('details');
  	}
});